VTK: Infovis/BoostGraphAlgorithms/vtkBoostGraphAdapter.h File Reference

| VTK 9.3.1

Classes | Namespaces | Macros | Functions
vtkBoostGraphAdapter.h File Reference
`#include "vtkAbstractArray.h"`
`#include "vtkDataArray.h"`
`#include "vtkDataObject.h"`
`#include "vtkDirectedGraph.h"`
`#include "vtkDistributedGraphHelper.h"`
`#include "vtkDoubleArray.h"`
`#include "vtkFloatArray.h"`
`#include "vtkIdTypeArray.h"`
`#include "vtkInformation.h"`
`#include "vtkIntArray.h"`
`#include "vtkMutableDirectedGraph.h"`
`#include "vtkMutableUndirectedGraph.h"`
`#include "vtkTree.h"`
`#include "vtkUndirectedGraph.h"`
`#include "vtkVariant.h"`
`#include <boost/version.hpp>`
`#include <utility>`
`#include <boost/config.hpp>`
`#include <boost/graph/adjacency_iterator.hpp>`
`#include <boost/graph/graph_traits.hpp>`
`#include <boost/graph/properties.hpp>`
`#include <boost/iterator/iterator_facade.hpp>`
`#include <boost/vector_property_map.hpp>`
Include dependency graph for vtkBoostGraphAdapter.h:

Go to the source code of this file.

## Classes
struct | boost::property_traits< vtkDataArray * >
struct | boost::property_traits< vtkAbstractArray * >
class | boost::vtk_vertex_iterator
class | boost::vtk_edge_iterator
class | boost::vtk_out_edge_pointer_iterator
class | boost::vtk_in_edge_pointer_iterator
struct | boost::vtkGraph_traversal_category
struct | boost::graph_traits< vtkGraph * >
struct | boost::vertex_property_type< vtkGraph * >
struct | boost::edge_property_type< vtkGraph * >
struct | boost::vertex_bundle_type< vtkGraph * >
struct | boost::edge_bundle_type< vtkGraph * >
struct | boost::graph_traits< vtkDirectedGraph * >
struct | boost::graph_traits< const vtkDirectedGraph * >
struct | boost::graph_traits< vtkDirectedGraph *const >
struct | boost::vertex_property_type< vtkDirectedGraph * >
struct | boost::vertex_property_type< vtkDirectedGraph *const >
struct | boost::edge_property_type< vtkDirectedGraph * >
struct | boost::edge_property_type< vtkDirectedGraph *const >
struct | boost::vertex_bundle_type< vtkDirectedGraph * >
struct | boost::vertex_bundle_type< vtkDirectedGraph *const >
struct | boost::edge_bundle_type< vtkDirectedGraph * >
struct | boost::edge_bundle_type< vtkDirectedGraph *const >
struct | boost::graph_traits< vtkTree * >
struct | boost::graph_traits< const vtkTree * >
struct | boost::graph_traits< vtkTree *const >
struct | boost::graph_traits< vtkUndirectedGraph * >
struct | boost::graph_traits< const vtkUndirectedGraph * >
struct | boost::graph_traits< vtkUndirectedGraph *const >
struct | boost::vertex_property_type< vtkUndirectedGraph * >
struct | boost::vertex_property_type< vtkUndirectedGraph *const >
struct | boost::edge_property_type< vtkUndirectedGraph * >
struct | boost::edge_property_type< vtkUndirectedGraph *const >
struct | boost::vertex_bundle_type< vtkUndirectedGraph * >
struct | boost::vertex_bundle_type< vtkUndirectedGraph *const >
struct | boost::edge_bundle_type< vtkUndirectedGraph * >
struct | boost::edge_bundle_type< vtkUndirectedGraph *const >
struct | boost::graph_traits< vtkMutableDirectedGraph * >
struct | boost::graph_traits< const vtkMutableDirectedGraph * >
struct | boost::graph_traits< vtkMutableDirectedGraph *const >
struct | boost::vertex_property_type< vtkMutableDirectedGraph * >
struct | boost::vertex_property_type< vtkMutableDirectedGraph *const >
struct | boost::edge_property_type< vtkMutableDirectedGraph * >
struct | boost::edge_property_type< vtkMutableDirectedGraph *const >
struct | boost::vertex_bundle_type< vtkMutableDirectedGraph * >
struct | boost::vertex_bundle_type< vtkMutableDirectedGraph *const >
struct | boost::edge_bundle_type< vtkMutableDirectedGraph * >
struct | boost::edge_bundle_type< vtkMutableDirectedGraph *const >
struct | boost::graph_traits< vtkMutableUndirectedGraph * >
struct | boost::graph_traits< const vtkMutableUndirectedGraph * >
struct | boost::graph_traits< vtkMutableUndirectedGraph *const >
struct | boost::vertex_property_type< vtkMutableUndirectedGraph * >
struct | boost::vertex_property_type< vtkMutableUndirectedGraph *const >
struct | boost::edge_property_type< vtkMutableUndirectedGraph * >
struct | boost::edge_property_type< vtkMutableUndirectedGraph *const >
struct | boost::vertex_bundle_type< vtkMutableUndirectedGraph * >
struct | boost::vertex_bundle_type< vtkMutableUndirectedGraph *const >
struct | boost::edge_bundle_type< vtkMutableUndirectedGraph * >
struct | boost::edge_bundle_type< vtkMutableUndirectedGraph *const >
class | boost::vertex_property< vtkGraph * >
class | boost::edge_property< vtkGraph * >
struct | boost::vtkGraphEdgeMap
struct | boost::property_traits< vtkGraphEdgeMap >
class | boost::vtkGraphEdgePropertyMapHelper< PMap >
class | boost::vtkGraphVertexPropertyMapHelper< PMap >
struct | boost::vtkGraphIndexMap
struct | boost::property_traits< vtkGraphIndexMap >
class | boost::vtkGraphPropertyMapMultiplier< PMap >
struct | boost::property_map< vtkGraph *, vertex_index_t >
struct | boost::property_map< vtkDirectedGraph *, vertex_index_t >
struct | boost::property_map< vtkUndirectedGraph *, vertex_index_t >
struct | boost::property_map< vtkGraph *, edge_index_t >
struct | boost::property_map< vtkDirectedGraph *, edge_index_t >
struct | boost::property_map< vtkUndirectedGraph *, edge_index_t >
struct | boost::property_map< vtkDirectedGraph *const, vertex_index_t >
struct | boost::property_map< vtkUndirectedGraph *const, vertex_index_t >
struct | boost::property_map< vtkDirectedGraph *const, edge_index_t >
struct | boost::property_map< vtkUndirectedGraph *const, edge_index_t >

## Namespaces
| boost
| Forward declaration required for Boost serialization.

## Macros
#define | vtkPropertyMapMacro(T, V)

## Functions
| boost::vtkPropertyMapMacro (vtkIntArray, int)
| boost::vtkPropertyMapMacro (vtkIdTypeArray, vtkIdType)
| boost::vtkPropertyMapMacro (vtkDoubleArray, double)
| boost::vtkPropertyMapMacro (vtkFloatArray, float)
double | boost::get (vtkDataArray *const &arr, vtkIdType key)
void | boost::put (vtkDataArray *arr, vtkIdType key, const double &value)
vtkVariant | boost::get (vtkAbstractArray *const &arr, vtkIdType key)
void | boost::put (vtkAbstractArray *arr, vtkIdType key, const vtkVariant &value)
bool | boost::has_no_edges (vtkGraph *g)
void | boost::remove_edge (graph_traits< vtkGraph * >::edge_descriptor e, vtkGraph *g)
boost::graph_traits< vtkGraph * >::vertex_descriptor | source (boost::graph_traits< vtkGraph * >::edge_descriptor e, vtkGraph *)
boost::graph_traits< vtkGraph * >::vertex_descriptor | target (boost::graph_traits< vtkGraph * >::edge_descriptor e, vtkGraph *)
std::pair< boost::graph_traits< vtkGraph * >::vertex_iterator, boost::graph_traits< vtkGraph * >::vertex_iterator > | vertices (vtkGraph *g)
std::pair< boost::graph_traits< vtkGraph * >::edge_iterator, boost::graph_traits< vtkGraph * >::edge_iterator > | edges (vtkGraph *g)
std::pair< boost::graph_traits< vtkGraph * >::out_edge_iterator, boost::graph_traits< vtkGraph * >::out_edge_iterator > | out_edges (boost::graph_traits< vtkGraph * >::vertex_descriptor u, vtkGraph *g)
std::pair< boost::graph_traits< vtkGraph * >::in_edge_iterator, boost::graph_traits< vtkGraph * >::in_edge_iterator > | in_edges (boost::graph_traits< vtkGraph * >::vertex_descriptor u, vtkGraph *g)
std::pair< boost::graph_traits< vtkGraph * >::adjacency_iterator, boost::graph_traits< vtkGraph * >::adjacency_iterator > | adjacent_vertices (boost::graph_traits< vtkGraph * >::vertex_descriptor u, vtkGraph *g)
boost::graph_traits< vtkGraph * >::vertices_size_type | num_vertices (vtkGraph *g)
boost::graph_traits< vtkGraph * >::edges_size_type | num_edges (vtkGraph *g)
boost::graph_traits< vtkGraph * >::degree_size_type | out_degree (boost::graph_traits< vtkGraph * >::vertex_descriptor u, vtkGraph *g)
boost::graph_traits< vtkDirectedGraph * >::degree_size_type | in_degree (boost::graph_traits< vtkDirectedGraph * >::vertex_descriptor u, vtkDirectedGraph *g)
boost::graph_traits< vtkGraph * >::degree_size_type | degree (boost::graph_traits< vtkGraph * >::vertex_descriptor u, vtkGraph *g)
boost::graph_traits< vtkMutableDirectedGraph * >::vertex_descriptor | add_vertex (vtkMutableDirectedGraph *g)
std::pair< boost::graph_traits< vtkMutableDirectedGraph * >::edge_descriptor, bool > | add_edge (boost::graph_traits< vtkMutableDirectedGraph * >::vertex_descriptor u, boost::graph_traits< vtkMutableDirectedGraph * >::vertex_descriptor v, vtkMutableDirectedGraph *g)
boost::graph_traits< vtkMutableUndirectedGraph * >::vertex_descriptor | add_vertex (vtkMutableUndirectedGraph *g)
std::pair< boost::graph_traits< vtkMutableUndirectedGraph * >::edge_descriptor, bool > | add_edge (boost::graph_traits< vtkMutableUndirectedGraph * >::vertex_descriptor u, boost::graph_traits< vtkMutableUndirectedGraph * >::vertex_descriptor v, vtkMutableUndirectedGraph *g)
property_traits< vtkGraphEdgeMap >::reference | boost::get (vtkGraphEdgeMap vtkNotUsed(arr), property_traits< vtkGraphEdgeMap >::key_type key)
template<typename PMap >
property_traits< PMap >::reference | boost::get (vtkGraphEdgePropertyMapHelper< PMap > helper, vtkEdgeType key)
template<typename PMap >
void | boost::put (vtkGraphEdgePropertyMapHelper< PMap > helper, vtkEdgeType key, const typename property_traits< PMap >::value_type &value)
template<typename PMap >
property_traits< PMap >::reference | boost::get (vtkGraphVertexPropertyMapHelper< PMap > helper, vtkIdType key)
template<typename PMap >
void | boost::put (vtkGraphVertexPropertyMapHelper< PMap > helper, vtkIdType key, const typename property_traits< PMap >::value_type &value)
property_traits< vtkGraphIndexMap >::reference | boost::get (vtkGraphIndexMap vtkNotUsed(arr), property_traits< vtkGraphIndexMap >::key_type key)
template<typename PMap >
property_traits< PMap >::reference | boost::get (vtkGraphPropertyMapMultiplier< PMap > multi, const typename property_traits< PMap >::key_type &key)
template<typename PMap >
void | boost::put (vtkGraphPropertyMapMultiplier< PMap > multi, const typename property_traits< PMap >::key_type &key, const typename property_traits< PMap >::value_type &value)
vtkGraphIndexMap | boost::get (vertex_index_t, vtkGraph *)
vtkGraphIndexMap | boost::get (edge_index_t, vtkGraph *)

## Macro Definition Documentation

## ◆ vtkPropertyMapMacro

#define vtkPropertyMapMacro | ( |  | T,
|  |  | V
| ) |  |

Value:
template <> \
struct property_traits<T*> \
{ \
typedef V value_type; \
typedef V reference; \
typedef vtkIdType key_type; \
typedef read_write_property_map_tag category; \
}; \
\
inline property_traits<T*>::reference get(T* const& arr, property_traits<T*>::key_type key) \
{ \
return arr->GetValue(key); \
} \
\
inline void put( \
T* arr, property_traits<T*>::key_type key, const property_traits<T*>::value_type& value) \
{ \
arr->InsertValue(key, value); \
}
boost::put
void put(vtkGraphPropertyMapMultiplier< PMap > multi, const typename property_traits< PMap >::key_type &key, const typename property_traits< PMap >::value_type &value)
Definition: vtkBoostGraphAdapter.h:1241
vtkX3D::reference
@ reference
Definition: vtkX3D.h:464
vtkX3D::key
@ key
Definition: vtkX3D.h:257
vtkX3D::value
@ value
Definition: vtkX3D.h:220
vtkIdType
int vtkIdType
Definition: vtkType.h:315

Definition at line 56 of file vtkBoostGraphAdapter.h.

## Function Documentation

## ◆ source()

boost::graph_traits<vtkGraph*>::vertex_descriptor source | ( | boost::graph_traits< vtkGraph * >::edge_descriptor | e,
|  | vtkGraph * |
| ) |  |
| inline

Definition at line 964 of file vtkBoostGraphAdapter.h.

## ◆ target()

boost::graph_traits<vtkGraph*>::vertex_descriptor target | ( | boost::graph_traits< vtkGraph * >::edge_descriptor | e,
|  | vtkGraph * |
| ) |  |
| inline

Definition at line 970 of file vtkBoostGraphAdapter.h.

## ◆ vertices()

std::pair<boost::graph_traits<vtkGraph*>::vertex_iterator, boost::graph_traits<vtkGraph*>::vertex_iterator> vertices | ( | vtkGraph * | g | ) |
| inline

Definition at line 978 of file vtkBoostGraphAdapter.h.

## ◆ edges()

std::pair<boost::graph_traits<vtkGraph*>::edge_iterator, boost::graph_traits<vtkGraph*>::edge_iterator> edges | ( | vtkGraph * | g | ) |
| inline

Definition at line 993 of file vtkBoostGraphAdapter.h.

## ◆ out_edges()

std::pair<boost::graph_traits<vtkGraph*>::out_edge_iterator, boost::graph_traits<vtkGraph*>::out_edge_iterator> out_edges | ( | boost::graph_traits< vtkGraph * >::vertex_descriptor | u,
|  | vtkGraph * | g
| ) |  |
| inline

Definition at line 1001 of file vtkBoostGraphAdapter.h.

## ◆ in_edges()

std::pair<boost::graph_traits<vtkGraph*>::in_edge_iterator, boost::graph_traits<vtkGraph*>::in_edge_iterator> in_edges | ( | boost::graph_traits< vtkGraph * >::vertex_descriptor | u,
|  | vtkGraph * | g
| ) |  |
| inline

Definition at line 1010 of file vtkBoostGraphAdapter.h.

## ◆ adjacent_vertices()

std::pair<boost::graph_traits<vtkGraph*>::adjacency_iterator, boost::graph_traits<vtkGraph*>::adjacency_iterator> adjacent_vertices | ( | boost::graph_traits< vtkGraph * >::vertex_descriptor | u,
|  | vtkGraph * | g
| ) |  |
| inline

Definition at line 1019 of file vtkBoostGraphAdapter.h.

## ◆ num_vertices()

boost::graph_traits<vtkGraph*>::vertices_size_type num_vertices | ( | vtkGraph * | g | ) |
| inline

Definition at line 1027 of file vtkBoostGraphAdapter.h.

## ◆ num_edges()

boost::graph_traits<vtkGraph*>::edges_size_type num_edges | ( | vtkGraph * | g | ) |
| inline

Definition at line 1032 of file vtkBoostGraphAdapter.h.

## ◆ out_degree()

boost::graph_traits<vtkGraph*>::degree_size_type out_degree | ( | boost::graph_traits< vtkGraph * >::vertex_descriptor | u,
|  | vtkGraph * | g
| ) |  |
| inline

Definition at line 1037 of file vtkBoostGraphAdapter.h.

## ◆ in_degree()

boost::graph_traits<vtkDirectedGraph*>::degree_size_type in_degree | ( | boost::graph_traits< vtkDirectedGraph * >::vertex_descriptor | u,
|  | vtkDirectedGraph * | g
| ) |  |
| inline

Definition at line 1043 of file vtkBoostGraphAdapter.h.

## ◆ degree()

boost::graph_traits<vtkGraph*>::degree_size_type degree | ( | boost::graph_traits< vtkGraph * >::vertex_descriptor | u,
|  | vtkGraph * | g
| ) |  |
| inline

Definition at line 1049 of file vtkBoostGraphAdapter.h.

## ◆ add_vertex() [1/2]

boost::graph_traits<vtkMutableDirectedGraph*>::vertex_descriptor add_vertex | ( | vtkMutableDirectedGraph * | g | ) |
| inline

Definition at line 1055 of file vtkBoostGraphAdapter.h.

## ◆ add_edge() [1/2]

std::pair<boost::graph_traits<vtkMutableDirectedGraph*>::edge_descriptor, bool> add_edge | ( | boost::graph_traits< vtkMutableDirectedGraph * >::vertex_descriptor | u,
|  | boost::graph_traits< vtkMutableDirectedGraph * >::vertex_descriptor | v,
|  | vtkMutableDirectedGraph * | g
| ) |  |
| inline

Definition at line 1061 of file vtkBoostGraphAdapter.h.

## ◆ add_vertex() [2/2]

boost::graph_traits<vtkMutableUndirectedGraph*>::vertex_descriptor add_vertex | ( | vtkMutableUndirectedGraph * | g | ) |
| inline

Definition at line 1069 of file vtkBoostGraphAdapter.h.

## ◆ add_edge() [2/2]

std::pair<boost::graph_traits<vtkMutableUndirectedGraph*>::edge_descriptor, bool> add_edge | ( | boost::graph_traits< vtkMutableUndirectedGraph * >::vertex_descriptor | u,
|  | boost::graph_traits< vtkMutableUndirectedGraph * >::vertex_descriptor | v,
|  | vtkMutableUndirectedGraph * | g
| ) |  |
| inline

Definition at line 1075 of file vtkBoostGraphAdapter.h.